/******************************************************************************/
/***         Generated by IBExpert 2020.4.21.2 23/03/2023 15:40:30          ***/
/******************************************************************************/

SET SQL DIALECT 3;

SET NAMES NONE;

CREATE DATABASE '127.0.0.1/3050:C:\Gold_Pro\DADOS.FDB'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 16384
DEFAULT CHARACTER SET NONE COLLATION NONE;



/******************************************************************************/
/***                                Domains                                 ***/
/******************************************************************************/

CREATE DOMAIN CODIGO AS
VARCHAR(12);



/******************************************************************************/
/***                               Generators                               ***/
/******************************************************************************/

CREATE GENERATOR GEN_ANALIZEOURO_ID;
SET GENERATOR GEN_ANALIZEOURO_ID TO 0;

CREATE GENERATOR GEN_CONTA_ID;
SET GENERATOR GEN_CONTA_ID TO 287229;

CREATE GENERATOR GEN_FINO_ID;
SET GENERATOR GEN_FINO_ID TO 0;

CREATE GENERATOR GEN_OPS_HISTORICO;
SET GENERATOR GEN_OPS_HISTORICO TO 0;

CREATE GENERATOR GEN_PESSOABLOQUSUARIO_ID;
SET GENERATOR GEN_PESSOABLOQUSUARIO_ID TO 0;

CREATE GENERATOR GEN_WBOTATENDIMENTOPARAM_ID;
SET GENERATOR GEN_WBOTATENDIMENTOPARAM_ID TO 0;

CREATE GENERATOR GEN_WBOTATENDIMENTO_ID;
SET GENERATOR GEN_WBOTATENDIMENTO_ID TO 0;

CREATE GENERATOR GEN_WBOTCONTATO_ID;
SET GENERATOR GEN_WBOTCONTATO_ID TO 11;

CREATE GENERATOR GEN_WBOTCONVERSACONTATO_ID;
SET GENERATOR GEN_WBOTCONVERSACONTATO_ID TO 0;

CREATE GENERATOR GEN_WBOTMENSAGEMAENVIAR_ID;
SET GENERATOR GEN_WBOTMENSAGEMAENVIAR_ID TO 0;



/******************************************************************************/
/***                               Exceptions                               ***/
/******************************************************************************/

CREATE EXCEPTION DELETAR_PESSOA 'Existem Lancamentos vinculados a este registro';

CREATE EXCEPTION DELETAR_USUARIO 'Usurio ADMIN No pode ser Excluido';



/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/



CREATE TABLE ANALIZEOURO (
    CODEMPRESA       VARCHAR(12) NOT NULL,
    IDANALIZE        VARCHAR(12) NOT NULL,
    DATA             DATE DEFAULT CURRENT_DATE,
    HORARIO          TIME DEFAULT CURRENT_TIME,
    PESOREAL         DOUBLE PRECISION DEFAULT 0,
    PESOSECO         DOUBLE PRECISION DEFAULT 0,
    PESOMOLHADO      DOUBLE PRECISION DEFAULT 0,
    PRECOGRAMA       DOUBLE PRECISION DEFAULT 0,
    TOTALPAGO        DOUBLE PRECISION DEFAULT 0,
    PRECOMIL         DOUBLE PRECISION DEFAULT 0,
    CLIENTE          VARCHAR(100),
    GARIMPO          VARCHAR(100),
    CODUSUARIO       VARCHAR(12),
    TEOR             DOUBLE PRECISION,
    PESOFINO         DOUBLE PRECISION DEFAULT 0,
    PRECOFINO        DOUBLE PRECISION DEFAULT 0,
    FUNDIDO          VARCHAR(1) DEFAULT '2' NOT NULL,
    PRECOFECHAMENTO  FLOAT
);

CREATE TABLE ANALIZEOURO_APAGADOS (
    CODEMPRESA        VARCHAR(12) NOT NULL,
    IDANALIZE         VARCHAR(12) NOT NULL,
    DATA              DATE DEFAULT CURRENT_DATE,
    HORARIO           TIME DEFAULT CURRENT_TIME,
    PESOREAL          DOUBLE PRECISION DEFAULT 0,
    PESOSECO          DOUBLE PRECISION DEFAULT 0,
    PESOMOLHADO       DOUBLE PRECISION DEFAULT 0,
    PRECOGRAMA        DOUBLE PRECISION DEFAULT 0,
    TOTALPAGO         DOUBLE PRECISION DEFAULT 0,
    PRECOMIL          DOUBLE PRECISION DEFAULT 0,
    CLIENTE           VARCHAR(100),
    GARIMPO           VARCHAR(100),
    CODUSUARIO        VARCHAR(12),
    TEOR              DOUBLE PRECISION,
    CODUSUARIOAPAGOU  VARCHAR(12),
    DATAAPAGOU        DATE DEFAULT CURRENT_DATE,
    HORARIOAPAGOU     TIME DEFAULT CURRENT_TIME,
    PESOFINO          DOUBLE PRECISION DEFAULT 0,
    PRECOFINO         DOUBLE PRECISION DEFAULT 0,
    FUNDIDO           VARCHAR(1) DEFAULT '2' NOT NULL,
    PRECOFECHAMENTO   FLOAT
);

CREATE TABLE ANALIZEOURO_CLIENTES (
    CLIENTE  VARCHAR(100) NOT NULL
);

CREATE TABLE ANALIZEOURO_COTACOES (
    CODEMPRESA  VARCHAR(12) NOT NULL,
    IDCOTACAO   VARCHAR(12) NOT NULL,
    DATA        DATE,
    HORARIO     TIME,
    PRECOMIL    DOUBLE PRECISION,
    PRECOGRAMA  DOUBLE PRECISION,
    CODUSUARIO  VARCHAR(12)
);

CREATE TABLE ANALIZEOURO_GARIMPOS (
    GARIMPO  VARCHAR(100) NOT NULL
);

CREATE TABLE AUDITORIA (
    CODEMPRESA    VARCHAR(12) NOT NULL,
    CODAUDITORIA  VARCHAR(12) NOT NULL,
    CODUSUARIO    VARCHAR(12),
    DATA          DATE,
    HORARIO       TIME,
    TERMINAL      VARCHAR(30),
    TABELA        VARCHAR(30),
    OPERACAO      VARCHAR(15),
    CONTEUDO      BLOB SUB_TYPE 0 SEGMENT SIZE 16384,
    IDCONTA       VARCHAR(12),
    CODOPS        VARCHAR(12)
);

CREATE TABLE BANCOS (
    CODBANCO   VARCHAR(12) NOT NULL,
    DESCRICAO  VARCHAR(60) NOT NULL,
    ATIVO      VARCHAR(1) DEFAULT '2'
);

CREATE TABLE CADCAIXAS (
    CODCAIXA   VARCHAR(12) NOT NULL,
    DESCRICAO  VARCHAR(60) NOT NULL,
    BANCO      VARCHAR(12),
    AGENCIA    VARCHAR(12),
    CIDADE     VARCHAR(60),
    FONE_AG    VARCHAR(15),
    GERENTE    VARCHAR(60),
    LIMITE     DOUBLE PRECISION,
    TIPO       VARCHAR(1) DEFAULT '2',
    ATIVO      VARCHAR(1) DEFAULT '2'
);

CREATE TABLE CONFIGURACOES (
    CODIGO    VARCHAR(12) NOT NULL,
    VERSAODB  INTEGER
);

CREATE TABLE CONTA (
    CODEMPRESA       VARCHAR(12) NOT NULL,
    IDCONTA          VARCHAR(12) NOT NULL,
    DATA             DATE DEFAULT CURRENT_DATE,
    CODIGO           VARCHAR(12) NOT NULL,
    TIPO1            VARCHAR(1) NOT NULL,
    TIPO2            VARCHAR(1) NOT NULL,
    TIPO3            VARCHAR(1) NOT NULL,
    TIPO4            VARCHAR(1) NOT NULL,
    VALOR            DOUBLE PRECISION,
    MIL              DOUBLE PRECISION,
    BRUTO            DOUBLE PRECISION,
    FINO             DOUBLE PRECISION,
    TEOR             DOUBLE PRECISION,
    HISTORICO        VARCHAR(100),
    CODUSUARIO       VARCHAR(20),
    HORARIO          TIME DEFAULT current_time,
    DATADIGITACAO    DATE,
    SUBTOTAL         NUMERIC(15,2),
    SUBTOTALF        NUMERIC(15,2),
    SUBTOTALGERALR   NUMERIC(15,2) DEFAULT 0,
    SUBTOTALGERALF   NUMERIC(15,2) DEFAULT 0,
    DEBITO_IDCONTA   VARCHAR(12),
    CREDITO_IDCONTA  VARCHAR(12),
    COTACAO          DOUBLE PRECISION,
    CODOPS           VARCHAR(12)
);

CREATE TABLE CONTA_APAGADOS (
    CODEMPRESA        VARCHAR(12) NOT NULL,
    IDCONTA           VARCHAR(12) NOT NULL,
    DATA              DATE DEFAULT CURRENT_DATE,
    CODIGO            VARCHAR(12) NOT NULL,
    TIPO1             VARCHAR(1) NOT NULL,
    TIPO2             VARCHAR(1) NOT NULL,
    TIPO3             VARCHAR(1) NOT NULL,
    TIPO4             VARCHAR(1) NOT NULL,
    VALOR             DOUBLE PRECISION NOT NULL,
    MIL               DOUBLE PRECISION,
    BRUTO             DOUBLE PRECISION,
    FINO              DOUBLE PRECISION,
    TEOR              DOUBLE PRECISION,
    HISTORICO         VARCHAR(100),
    CODUSUARIO        VARCHAR(20) NOT NULL,
    HORARIO           TIME DEFAULT current_time NOT NULL,
    CODUSUARIOAPAGOU  VARCHAR(12),
    DATAAPAGOU        DATE default current_date,
    HORARIOAPAGOU     TIME DEFAULT CURRENT_TIME,
    DATADIGITACAO     DATE,
    SUBTOTAL          NUMERIC(15,2),
    SUBTOTALF         NUMERIC(15,2),
    SUBTOTALGERALR    NUMERIC(15,2) DEFAULT 0,
    SUBTOTALGERALF    NUMERIC(15,2) DEFAULT 0
);

CREATE TABLE CONTA_TEMP (
    DATA            DATE DEFAULT CURRENT_DATE,
    CODIGO          VARCHAR(12),
    TIPO1           VARCHAR(1),
    TIPO2           VARCHAR(1),
    TIPO3           VARCHAR(1),
    TIPO4           VARCHAR(1),
    CREDITO         NUMERIC(15,2),
    DEBITO          NUMERIC(15,2),
    SUBTOTAL        NUMERIC(15,2),
    SUBTOTALF       NUMERIC(15,2),
    MIL             DOUBLE PRECISION,
    BRUTO           DOUBLE PRECISION,
    FINO            DOUBLE PRECISION,
    TEOR            DOUBLE PRECISION,
    HISTORICO       VARCHAR(100),
    CODUSUARIO      VARCHAR(20),
    NOME            VARCHAR(100),
    USUARIO         VARCHAR(50),
    IDCONTA         VARCHAR(12),
    CODEMPRESA      VARCHAR(12),
    DATADIGITACAO   DATE,
    VALOR           NUMERIC(15,2) DEFAULT 0,
    SUBTOTALGERALR  NUMERIC(15,2) DEFAULT 0,
    SUBTOTALGERALF  NUMERIC(15,2) DEFAULT 0
);

CREATE TABLE EMPRESA (
    CODEMPRESA            VARCHAR(12) NOT NULL,
    FANTASIA              VARCHAR(100),
    RAZAO                 VARCHAR(100),
    CNPJ                  VARCHAR(20),
    IE                    VARCHAR(20),
    ENDERECO              VARCHAR(100),
    NUMERO                VARCHAR(20),
    BAIRRO                VARCHAR(100),
    CIDADE                VARCHAR(100),
    UF                    VARCHAR(2),
    CEP                   VARCHAR(20),
    FONE1                 VARCHAR(20),
    FONE2                 VARCHAR(20),
    FONE3                 VARCHAR(20),
    FONE4                 VARCHAR(20),
    EMAIL                 VARCHAR(50),
    RESPONSAVEL           VARCHAR(100),
    USB                   VARCHAR(15),
    LOGO                  BLOB SUB_TYPE 2 SEGMENT SIZE 16384,
    ESLOGAN               VARCHAR(50),
    LICENCA1              VARCHAR(100),
    LICENCA2              VARCHAR(100),
    LICENCA3              VARCHAR(100),
    LICENCA4              VARCHAR(100),
    DATA_ULTIMAALTERACAO  TIMESTAMP DEFAULT current_timestamp
);

CREATE TABLE FINO (
    CODEMPRESA  VARCHAR(12) NOT NULL,
    CODFINO     VARCHAR(12) NOT NULL,
    DATA        TIMESTAMP,
    FINO        DOUBLE PRECISION,
    ID          INTEGER
);

CREATE TABLE OPS (
    CODEMPRESA         VARCHAR(12) NOT NULL,
    CODOPS             VARCHAR(12) NOT NULL,
    FAVORECIDO         VARCHAR(60),
    VALOR              DOUBLE PRECISION,
    CONTA              VARCHAR(30),
    AGENCIA            VARCHAR(30),
    BANCO              VARCHAR(30),
    CIDADE             VARCHAR(60),
    ESTADO             VARCHAR(2),
    REMETENTE          VARCHAR(60),
    COMPRAOURO         VARCHAR(60),
    EMISSAO            TIMESTAMP,
    OBSER1             VARCHAR(100),
    CPFCNPJFAVORECIDO  VARCHAR(22),
    SEL                VARCHAR(1) DEFAULT '0',
    CODUSUARIO         VARCHAR(12),
    TAXA               DOUBLE PRECISION,
    DEBITO_IDCONTA     VARCHAR(12),
    CREDITO_IDCONTA    VARCHAR(12),
    DEBITO_CODIGO      VARCHAR(12),
    CREDITO_CODIGO     VARCHAR(12),
    ENDERECO           VARCHAR(60),
    SITUACAO           INTEGER,
    TIPOPAGAMENTO      INTEGER,
    FINO               FLOAT,
    MIL                FLOAT,
    BAIRRO             VARCHAR(60),
    GEROULIQUIDACAO    VARCHAR(1) DEFAULT 'N',
    DATADIGITACAO      DATE DEFAULT current_date,
    PIXTIPO            INTEGER,
    PIXCHAVE           VARCHAR(200),
    DOCUMENTO          VARCHAR(200)
);

CREATE TABLE OPS_APAGADOS (
    CODEMPRESA         VARCHAR(12) NOT NULL,
    CODOPS             VARCHAR(12) NOT NULL,
    FAVORECIDO         VARCHAR(60),
    VALOR              DOUBLE PRECISION,
    CONTA              VARCHAR(30),
    AGENCIA            VARCHAR(30),
    BANCO              VARCHAR(30),
    CIDADE             VARCHAR(60),
    ESTADO             VARCHAR(2),
    REMETENTE          VARCHAR(60),
    COMPRAOURO         VARCHAR(60),
    EMISSAO            TIMESTAMP,
    OBSER1             VARCHAR(100),
    CPFCNPJFAVORECIDO  VARCHAR(22),
    SEL                VARCHAR(1) DEFAULT '0',
    CODUSUARIO         VARCHAR(12),
    TAXA               DOUBLE PRECISION,
    DEBITO_IDCONTA     VARCHAR(12),
    CREDITO_IDCONTA    VARCHAR(12),
    DEBITO_CODIGO      VARCHAR(12),
    CREDITO_CODIGO     VARCHAR(12),
    ENDERECO           VARCHAR(60),
    SITUACAO           INTEGER,
    TIPOPAGAMENTO      INTEGER,
    FINO               FLOAT,
    MIL                FLOAT,
    BAIRRO             VARCHAR(60),
    GEROULIQUIDACAO    VARCHAR(1),
    CODUSUARIOAPAGOU   VARCHAR(12),
    HORAAPAGOU         DATE default current_date,
    HORARIOAPAGOU      TIME DEFAULT CURRENT_TIME,
    DATADIGITACAO      DATE DEFAULT current_date,
    DOCUMENTO          VARCHAR(200)
);

CREATE TABLE OPS_BANCO (
    BANCO  VARCHAR(30) NOT NULL
);

CREATE TABLE OPS_CIDADES (
    CIDADE  VARCHAR(60)
);

CREATE TABLE OPS_COMPRAOURO (
    COMPRAOURO  VARCHAR(60) NOT NULL
);

CREATE TABLE OPS_HISTORICO (
    CODHISTORICO       VARCHAR(12) NOT NULL,
    CODEMPRESA         VARCHAR(12) NOT NULL,
    CODOPS             VARCHAR(12) NOT NULL,
    FAVORECIDO         VARCHAR(60),
    VALOR              DOUBLE PRECISION,
    CONTA              VARCHAR(15),
    AGENCIA            VARCHAR(10),
    BANCO              VARCHAR(15),
    CIDADE             VARCHAR(15),
    ESTADO             VARCHAR(2),
    REMETENTE          VARCHAR(60),
    CODBANCO           VARCHAR(4),
    COMPRAOURO         VARCHAR(60),
    EMISSAO            TIMESTAMP,
    TICKET             VARCHAR(1),
    OBSER1             VARCHAR(100),
    CPFCNPJFAVORECIDO  VARCHAR(22),
    SEL                VARCHAR(1) DEFAULT '0',
    CODUSUARIO         VARCHAR(12),
    DOCUMENTO          VARCHAR(200)
);

CREATE TABLE OPS_LIQUIDACAO (
    CODOPLIQUIDACAO  VARCHAR(12) NOT NULL,
    CODEMPRESA       VARCHAR(12) NOT NULL,
    NOME             VARCHAR(120) NOT NULL,
    REMETENTE        VARCHAR(120) NOT NULL,
    CPFCNPJ          VARCHAR(20),
    RGIE             VARCHAR(20),
    DATA             DATE DEFAULT current_date NOT NULL,
    HORA             TIME DEFAULT current_time NOT NULL,
    CODUSUARIO       VARCHAR(12) NOT NULL,
    NOTAFISCAL       VARCHAR(30),
    SITUACAO         INTEGER DEFAULT 1 NOT NULL,
    TOTAL            NUMERIC(15,2) DEFAULT 0.00 NOT NULL
);

CREATE TABLE OPS_LIQUIDACAO_OPS (
    CODOPLIQUIDACAO  VARCHAR(12) NOT NULL,
    CODOPS           VARCHAR(12) NOT NULL,
    CODEMPRESA       VARCHAR(12) NOT NULL
);

CREATE TABLE PARAMETROS (
    CODEMPRESA                   VARCHAR(12),
    CODCONTACAIXA                VARCHAR(12),
    DATAINICIALOPS               DATE DEFAULT current_date NOT NULL,
    DATAFINALOPS                 DATE DEFAULT current_date NOT NULL,
    MOSTRAOURO_CAIXA_DH          VARCHAR(1) DEFAULT 'N' NOT NULL,
    CONTA_CLIENTE_EXCLUIDA       VARCHAR(100),
    CONTA_REMESSSA_OURO          VARCHAR(100),
    MILMINIMOCLIENTEOURO         DECIMAL(15,2),
    PRECOMILPADRAO               DOUBLE PRECISION,
    PRECOMILCLIENTEOURO          DECIMAL(15,2),
    ATUALIZAPRECOMILPADRAO       VARCHAR(1),
    ATUALIZAPRECOMILCLIENTEOURO  VARCHAR(1),
    DATADOSISTEMA_OPS            VARCHAR(1),
    PARAMETRO1                   VARCHAR(12),
    PARAMETRO2                   VARCHAR(12),
    TEORMINIMO                   DOUBLE PRECISION DEFAULT 30 NOT NULL,
    TEORMAXIMO                   DOUBLE PRECISION DEFAULT 100 NOT NULL,
    CONTA_FECHAMEMENTO           VARCHAR(12),
    PRECO_FECHAMENTO             NUMERIC(15,4) DEFAULT 0.0000,
    CONTA_TRANSITO               VARCHAR(12),
    CONTA_COMPRA_OURO            VARCHAR(12),
    CONTA_COFRE                  VARCHAR(12),
    CONTA_ANALIZE                VARCHAR(12),
    CONTA_RETENCAO               VARCHAR(12),
    CONTA_TICKET                 VARCHAR(12),
    DATAMILPADRAO                DATE,
    EDITATEORANALIZE             VARCHAR(1),
    UTILIZACOTACAOANALIZE        VARCHAR(1),
    OPS_USACONTADEBITO           VARCHAR(1),
    MOSTRAAVULSOFECHAMENTO       VARCHAR(1),
    IMPTICKETOPS                 VARCHAR(1),
    IMPTICKETCONTA               VARCHAR(1),
    EDITAGRAMAFUNDIDOANALIZE     VARCHAR(1),
    USASUBTOTALPESQUISA          VARCHAR(1),
    CONTALANCOUROSEMTEOR         VARCHAR(1)
);

CREATE TABLE PESSOABLOQUSUARIO (
    CODPESSOABLOQUSUARIO  VARCHAR(12) NOT NULL,
    CODEMPRESA            VARCHAR(12) NOT NULL,
    CODPESSOA             VARCHAR(12) NOT NULL,
    CODUSUARIO            VARCHAR(12) NOT NULL
);

CREATE TABLE PESSOAS (
    CODEMPRESA            VARCHAR(12) NOT NULL,
    CODPESSOA             VARCHAR(12) NOT NULL,
    TIPO                  VARCHAR(1),
    NOME                  VARCHAR(100),
    RAZAO                 VARCHAR(100),
    CPF_CNPJ              VARCHAR(20) DEFAULT '',
    FONE                  VARCHAR(15),
    FAX                   VARCHAR(15),
    ENDERECO              VARCHAR(100),
    BAIRRO                VARCHAR(60),
    CIDADE                VARCHAR(60),
    ESTADO                VARCHAR(2),
    CEP                   VARCHAR(9),
    DT_CAD                DATE,
    OBS                   VARCHAR(1000),
    RENDAMENSAL           DOUBLE PRECISION DEFAULT 0,
    LIMITE                DOUBLE PRECISION DEFAULT 0,
    DTNASC                DATE,
    CONJUGUE              VARCHAR(40),
    SEXO                  VARCHAR(1),
    PROF                  VARCHAR(30),
    CIVIL                 VARCHAR(1),
    TRABALHO              VARCHAR(50),
    ENDTRAB               VARCHAR(40),
    FONETRAB              VARCHAR(15),
    DATAADM               DATE,
    OPERADOR              VARCHAR(10),
    ORGAOEXP              VARCHAR(10),
    UFORGAOEXP            VARCHAR(10),
    CELULAR               VARCHAR(15),
    CONTATO               VARCHAR(30),
    EMAIL                 VARCHAR(40),
    FONE2                 VARCHAR(15),
    FONEP                 VARCHAR(15),
    FONEM                 VARCHAR(15),
    PAI                   VARCHAR(50),
    MAE                   VARCHAR(50),
    SITE                  VARCHAR(30),
    MSN                   VARCHAR(30),
    TIPOIMOVEL            VARCHAR(1),
    TEMPORESIDENCIA       VARCHAR(15),
    LOCALNASCIMENTO       VARCHAR(15),
    ENDERECO2             VARCHAR(40),
    BAIRRO2               VARCHAR(20),
    CIDADE2               VARCHAR(30),
    ESTADO2               VARCHAR(2),
    CEP2                  VARCHAR(9),
    FONEC                 VARCHAR(15),
    RESP_COBRANCA         VARCHAR(20),
    DESC_AUTOMATICO       DOUBLE PRECISION DEFAULT 0,
    BLOQUEIADEBITOS       VARCHAR(1),
    BLOQUEIALIMITE        VARCHAR(1),
    SOMENTEAVISTA         VARCHAR(1),
    STATUS                VARCHAR(1),
    FISJUR                VARCHAR(1),
    RG_IE                 VARCHAR(20),
    CREDITO1              DOUBLE PRECISION,
    CREDITO2              DOUBLE PRECISION,
    TIPO2                 VARCHAR(1) DEFAULT '2',
    CODUSUARIO            VARCHAR(12),
    FORNECEDOR_CODPESSOA  VARCHAR(12)
);

CREATE TABLE PLANO_CONTAS (
    CODPCONTA  VARCHAR(12),
    DESCRICAO  VARCHAR(100),
    CONTABIL   VARCHAR(1) DEFAULT '2',
    ATIVO      VARCHAR(1) DEFAULT '2'
);

CREATE TABLE SEQUENCIAS (
    CODEMPRESA  VARCHAR(12) NOT NULL,
    TABELA      VARCHAR(20) NOT NULL,
    CAMPO       VARCHAR(20) NOT NULL,
    PROXIMO     VARCHAR(12) NOT NULL
);

CREATE TABLE TEMP_REL (
    NOME       VARCHAR(100),
    CODIGO     VARCHAR(12),
    DESCRICAO  VARCHAR(100),
    DATA1      DATE,
    DATA2      DATE,
    TEXTO1     VARCHAR(100),
    TEXTO2     VARCHAR(100),
    TEXTO3     VARCHAR(100),
    TEXTO4     VARCHAR(100),
    TEXTO5     VARCHAR(100),
    TEXTO6     VARCHAR(100),
    TEXTO7     VARCHAR(100),
    TEXTO8     VARCHAR(100),
    TEXTO9     VARCHAR(100),
    TEXTO10    VARCHAR(100),
    TEXTO11    VARCHAR(100),
    TEXTO12    VARCHAR(100),
    TEXTO13    VARCHAR(100),
    TEXTO14    VARCHAR(100),
    TEXTO15    VARCHAR(100),
    TEXTO16    VARCHAR(100),
    TEXTO17    VARCHAR(100)
);

CREATE TABLE TERMINAIS (
    TERMINAL          VARCHAR(100) NOT NULL,
    SENHA             VARCHAR(100),
    CONTRASENHA       VARCHAR(100),
    ULTIMOACESSO      DATE,
    CODULTIMOUSUARIO  VARCHAR(12),
    LOGADO            VARCHAR(1),
    HORARIO           TIME
);

CREATE TABLE TMP_CC_CLIENTE (
    IDCONTA    VARCHAR(12) NOT NULL,
    DATA       DATE DEFAULT CURRENT_DATE,
    CODIGO     VARCHAR(12) NOT NULL,
    TIPO1      VARCHAR(1) NOT NULL,
    VALOR      DOUBLE PRECISION NOT NULL,
    MIL        DOUBLE PRECISION,
    BRUTO      DOUBLE PRECISION,
    FINO       DOUBLE PRECISION,
    TEOR       DOUBLE PRECISION,
    HISTORICO  VARCHAR(100),
    SUBTOTAL   DOUBLE PRECISION
);

CREATE TABLE TMP_ESTATISTICA_DET (
    CODEMPRESA  VARCHAR(12),
    DATA        DATE,
    HISTORICO   VARCHAR(100),
    CODIGO      VARCHAR(12),
    TIPO1       VARCHAR(1),
    TIPO2       VARCHAR(1),
    TIPO3       VARCHAR(1),
    TIPO4       VARCHAR(1),
    VALOR       NUMERIC(15,2),
    MIL         NUMERIC(15,2),
    BRUTO       NUMERIC(15,2),
    FINO        NUMERIC(15,2),
    TEOR        NUMERIC(15,2),
    NOME        VARCHAR(100),
    USUARIO     VARCHAR(30),
    SUBTOTAL    NUMERIC(15,2),
    SUBTOTALF   NUMERIC(15,2)
);

CREATE TABLE TMP_EXTRATOCAIXAOURO (
    IDCONTA        VARCHAR(12),
    DATA           DATE DEFAULT CURRENT_DATE,
    CODIGO         VARCHAR(12),
    TIPO1          VARCHAR(1),
    HISTORICO      VARCHAR(100),
    NOME           VARCHAR(100),
    CREDITOFINO    DOUBLE PRECISION,
    DEBITOFINO     DOUBLE PRECISION,
    SUBTOTALFINO   DOUBLE PRECISION,
    CREDITOBRUTO   DOUBLE PRECISION,
    DEBITOBRUTO    DOUBLE PRECISION,
    SUBTOTALBRUTO  DOUBLE PRECISION,
    TEOR           DOUBLE PRECISION
);

CREATE TABLE TMP_EXTRATOCAXAIXA (
    IDCONTA    VARCHAR(12) NOT NULL,
    DATA       DATE DEFAULT CURRENT_DATE,
    CODIGO     VARCHAR(12) NOT NULL,
    TIPO1      VARCHAR(1) NOT NULL,
    HISTORICO  VARCHAR(100),
    NOME       VARCHAR(100),
    CREDITO    DOUBLE PRECISION,
    DEBITO     DOUBLE PRECISION,
    SUBTOTAL   DOUBLE PRECISION
);

CREATE TABLE USUARIO (
    CODEMPRESA        VARCHAR(12) NOT NULL,
    CODUSUARIO        VARCHAR(12) NOT NULL,
    USUARIO           VARCHAR(20) NOT NULL,
    SENHA             VARCHAR(50),
    ATIVO             VARCHAR(1) DEFAULT 'N',
    DT_ULTIMO_ACESSO  DATE,
    AUDITORIA         VARCHAR(1),
    PRIMEIROACESSO    VARCHAR(1)
);

CREATE TABLE USUARIO_ACESSOS (
    CODEMPRESA  VARCHAR(12) NOT NULL,
    CODUSUARIO  VARCHAR(12) NOT NULL,
    MENU        VARCHAR(20) NOT NULL,
    NOME_MENU   VARCHAR(60),
    ACESSO      VARCHAR(1) DEFAULT 'N',
    GRUPO       INTEGER DEFAULT 0,
    VALOR       DOUBLE PRECISION default '0,00'
);

CREATE TABLE WBOTATENDIMENTO (
    ID              INTEGER NOT NULL,
    DHABERTURA      TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL,
    WBOTCONTATO_ID  INTEGER NOT NULL,
    SITUACAO        VARCHAR(1) NOT NULL,
    TIPO            VARCHAR(3) NOT NULL,
    EXECUTADO       VARCHAR(1) NOT NULL,
    CICLO           VARCHAR(30),
    OPCAO           INTEGER,
    DHFECHAMENTO    TIMESTAMP
);

CREATE TABLE WBOTATENDIMENTOPARAM (
    ID                  INTEGER NOT NULL,
    WBOTATENDIMENTO_ID  INTEGER NOT NULL,
    ITEM                INTEGER NOT NULL,
    NOME                VARCHAR(50) NOT NULL,
    VALOR               VARCHAR(50)
);

CREATE TABLE WBOTCONTATO (
    ID                   INTEGER NOT NULL,
    WBOTUSUARIO_ID       INTEGER,
    NOME                 VARCHAR(100),
    NOME_AGENDA          VARCHAR(100),
    TELEFONE             VARCHAR(30) NOT NULL,
    ULTIMA_ATUALIZACAO   TIMESTAMP,
    BOT_BLOQUEADO        VARCHAR(1),
    FOTO                 BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    AGUARDANDO_RESPOSTA  VARCHAR(1) DEFAULT 'S',
    FINALIZADO           VARCHAR(1) DEFAULT 'N',
    CONTATO              VARCHAR(1)
);

CREATE TABLE WBOTCONVERSACONTATO (
    ID                    INTEGER NOT NULL,
    WBOTCONTATO_ID        INTEGER NOT NULL,
    WBOTUSUARIO_ID        INTEGER,
    MENSAGEM              BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ENVIADA_PELO_CONTATO  VARCHAR(1),
    DATA_HORA             TIMESTAMP NOT NULL,
    CICLO                 VARCHAR(30),
    OPCAO                 INTEGER,
    TIPO                  VARCHAR(20),
    IDENTIFICADOR         VARCHAR(100)
);

CREATE TABLE WBOTMENSAGEMAENVIAR (
    ID              INTEGER NOT NULL,
    TELEFONE        VARCHAR(30),
    WBOTCONTATO_ID  INTEGER,
    ENVIADA         VARCHAR(1) NOT NULL,
    MENSAGEM        BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    ARQUIVO         BLOB SUB_TYPE 0 SEGMENT SIZE 80,
    ARQUIVONOME     VARCHAR(100)
);



/******************************************************************************/
/***                           Unique constraints                           ***/
/******************************************************************************/

ALTER TABLE USUARIO ADD CONSTRAINT UNQ1_USUARIO UNIQUE (CODEMPRESA, USUARIO);
ALTER TABLE WBOTATENDIMENTOPARAM ADD CONSTRAINT UNQ1_WBOTATENDIMENTOPARAM UNIQUE (WBOTATENDIMENTO_ID, ITEM);


/******************************************************************************/
/***                              Primary keys                              ***/
/******************************************************************************/

ALTER TABLE ANALIZEOURO ADD CONSTRAINT PK_ANALIZEOURO PRIMARY KEY (CODEMPRESA, IDANALIZE);
ALTER TABLE ANALIZEOURO_APAGADOS ADD CONSTRAINT PK_ANALIZEOURO_APAGADOS PRIMARY KEY (CODEMPRESA, IDANALIZE);
ALTER TABLE ANALIZEOURO_CLIENTES ADD CONSTRAINT PK_ANALIZEOURO_CLIENTES PRIMARY KEY (CLIENTE);
ALTER TABLE ANALIZEOURO_COTACOES ADD CONSTRAINT PK_ANALIZEOURO_COTACOES PRIMARY KEY (CODEMPRESA, IDCOTACAO);
ALTER TABLE ANALIZEOURO_GARIMPOS ADD CONSTRAINT PK_ANALIZEOURO_GARIMPOS PRIMARY KEY (GARIMPO);
ALTER TABLE AUDITORIA ADD CONSTRAINT PK_AUDITORIA PRIMARY KEY (CODEMPRESA, CODAUDITORIA);
ALTER TABLE BANCOS ADD CONSTRAINT PK_BANCOS PRIMARY KEY (CODBANCO);
ALTER TABLE CADCAIXAS ADD CONSTRAINT PK_CADCAIXAS PRIMARY KEY (CODCAIXA);
ALTER TABLE CONFIGURACOES ADD CONSTRAINT PK_CONFIGURACOES PRIMARY KEY (CODIGO);
ALTER TABLE CONTA ADD CONSTRAINT PK_CONTA PRIMARY KEY (CODEMPRESA, IDCONTA, CODIGO);
ALTER TABLE CONTA_APAGADOS ADD CONSTRAINT PK_CONTA_APAGADOS PRIMARY KEY (CODEMPRESA, IDCONTA, CODIGO);
ALTER TABLE EMPRESA ADD CONSTRAINT PK_EMPRESA PRIMARY KEY (CODEMPRESA);
ALTER TABLE FINO ADD CONSTRAINT PK_FINO PRIMARY KEY (CODEMPRESA, CODFINO);
ALTER TABLE OPS ADD CONSTRAINT PK_OPS PRIMARY KEY (CODEMPRESA, CODOPS);
ALTER TABLE OPS_LIQUIDACAO ADD CONSTRAINT PK_OPS_LIQUIDACAO PRIMARY KEY (CODOPLIQUIDACAO, CODEMPRESA);
ALTER TABLE PESSOABLOQUSUARIO ADD CONSTRAINT PK_PESSOABLOQUSUARIO PRIMARY KEY (CODPESSOABLOQUSUARIO);
ALTER TABLE PESSOAS ADD CONSTRAINT PK_PESSOAS PRIMARY KEY (CODPESSOA, CODEMPRESA);
ALTER TABLE SEQUENCIAS ADD CONSTRAINT PK_SEQUENCIAS PRIMARY KEY (CODEMPRESA, TABELA);
ALTER TABLE TERMINAIS ADD CONSTRAINT PK_TERMINAIS PRIMARY KEY (TERMINAL);
ALTER TABLE USUARIO ADD CONSTRAINT PK_USUARIO PRIMARY KEY (CODEMPRESA, CODUSUARIO);
ALTER TABLE USUARIO_ACESSOS ADD CONSTRAINT PK_USUARIO_ACESSOS PRIMARY KEY (CODEMPRESA, CODUSUARIO, MENU);
ALTER TABLE WBOTATENDIMENTO ADD CONSTRAINT PK_WBOTATENDIMENTO PRIMARY KEY (ID);
ALTER TABLE WBOTATENDIMENTOPARAM ADD CONSTRAINT PK_WBOTATENDIMENTOPARAM PRIMARY KEY (ID);
ALTER TABLE WBOTCONTATO ADD CONSTRAINT PK_WBOTCONTATO PRIMARY KEY (ID);
ALTER TABLE WBOTCONVERSACONTATO ADD CONSTRAINT PK_WBOTCONVERSACONTATO PRIMARY KEY (ID);
ALTER TABLE WBOTMENSAGEMAENVIAR ADD CONSTRAINT PK_WBOTMENSAGEMAENVIAR PRIMARY KEY (ID);


/******************************************************************************/
/***                              Foreign keys                              ***/
/******************************************************************************/

ALTER TABLE ANALIZEOURO ADD CONSTRAINT FK_ANALIZEOURO_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE ANALIZEOURO_APAGADOS ADD CONSTRAINT FK_ANALIZEOURO_APAGADOS_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE ANALIZEOURO_COTACOES ADD CONSTRAINT FK_ANALIZEOURO_COTACOES_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE CONTA ADD CONSTRAINT FK_CONTA_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE CONTA_APAGADOS ADD CONSTRAINT FK_CONTA_APAGADOS_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE FINO ADD CONSTRAINT FK_FINO_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE OPS ADD CONSTRAINT FK_OPS_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE OPS_LIQUIDACAO_OPS ADD CONSTRAINT FK_OPS_LIQUIDACAO_OPS_1 FOREIGN KEY (CODOPLIQUIDACAO, CODEMPRESA) REFERENCES OPS_LIQUIDACAO (CODOPLIQUIDACAO, CODEMPRESA);
ALTER TABLE OPS_LIQUIDACAO_OPS ADD CONSTRAINT FK_OPS_LIQUIDACAO_OPS_2 FOREIGN KEY (CODEMPRESA, CODOPS) REFERENCES OPS (CODEMPRESA, CODOPS);
ALTER TABLE PESSOABLOQUSUARIO ADD CONSTRAINT FK_PESSOABLOQUSUARIO_1 FOREIGN KEY (CODPESSOA, CODEMPRESA) REFERENCES PESSOAS (CODPESSOA, CODEMPRESA);
ALTER TABLE PESSOAS ADD CONSTRAINT FK_PESSOAS_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE SEQUENCIAS ADD CONSTRAINT FK_SEQUENCIAS_1 FOREIGN KEY (CODEMPRESA) REFERENCES EMPRESA (CODEMPRESA);
ALTER TABLE WBOTCONVERSACONTATO ADD CONSTRAINT FK_WBOTCONVERSACONTATO_1 FOREIGN KEY (WBOTCONTATO_ID) REFERENCES WBOTCONTATO (ID);
ALTER TABLE WBOTMENSAGEMAENVIAR ADD CONSTRAINT FK_WBOTMENSAGEMAENVIAR_1 FOREIGN KEY (WBOTCONTATO_ID) REFERENCES WBOTCONTATO (ID);


/******************************************************************************/
/***                                Indices                                 ***/
/******************************************************************************/

CREATE INDEX IDX_CONTA_1 ON CONTA (CODIGO, DATA);
CREATE INDEX IDX_CONTA_2 ON CONTA (CODIGO);
CREATE INDEX OPS_IDX1 ON OPS (FAVORECIDO);
CREATE INDEX OPS_IDX2 ON OPS (REMETENTE);
CREATE INDEX OPS_IDX3 ON OPS (EMISSAO);
CREATE INDEX OPS_IDX4 ON OPS (CONTA);
CREATE INDEX OPS_IDX5 ON OPS (VALOR);
CREATE INDEX PESSOAS_IDX1 ON PESSOAS (CODEMPRESA);


/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/



SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: ANALIZEOURO_AI0 */
CREATE TRIGGER ANALIZEOURO_AI0 FOR ANALIZEOURO
ACTIVE AFTER INSERT POSITION 0
AS
declare variable qtd integer;
begin
  /* Trigger text */
  if (new.cliente is not null) then
  begin
    select coalesce(count(*),0) from analizeouro_clientes where cliente = new.cliente into :qtd;
    if (:qtd = 0) then
    begin
      insert into analizeouro_clientes
        (cliente)
        values
        (new.cliente);
    end
  end
  if (new.garimpo is not null) then
  begin
    select coalesce(count(*),0) from analizeouro_garimpos where garimpo = new.garimpo into :qtd;
    if (:qtd = 0) then
    begin
      insert into analizeouro_garimpos
        (garimpo)
        values
        (new.garimpo);
    end
  end
end
^

/* Trigger: ANALIZEOURO_BI0 */
CREATE TRIGGER ANALIZEOURO_BI0 FOR ANALIZEOURO
ACTIVE BEFORE INSERT POSITION 0
AS
declare variable xid integer;
begin
  xid = gen_id(GEN_ANALIZEOURO_ID,0);
  if (xid = 0) then
  begin
    select max(cast(idanalize as integer)) as id from analizeouro where idanalize <> '' into :xid;
    new.idanalize = gen_id(GEN_ANALIZEOURO_ID,(xid + 1));
  end
  if (new.idanalize is null) then
    new.idanalize = gen_id(GEN_ANALIZEOURO_ID,1);
  /* Trigger text
  ALTER SEQUENCE GEN_ANALIZEOURO_ID RESTART WITH 1
  */
end
^

/* Trigger: CONTA_BI0 */
CREATE TRIGGER CONTA_BI0 FOR CONTA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.IDCONTA IS NULL) THEN
    NEW.IDCONTA = GEN_ID(GEN_CONTA_ID,1);
END
^

/* Trigger: FINO_BI */
CREATE TRIGGER FINO_BI FOR FINO
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(GEN_FINO_ID,1);
END
^

/* Trigger: OPS_AI0 */
CREATE TRIGGER OPS_AI0 FOR OPS
ACTIVE AFTER INSERT OR UPDATE POSITION 0
AS
declare variable qtd integer;
begin
  if (trim(new.banco) <> '') then
  begin
    select coalesce(count(*),0) from ops_banco where banco = new.banco into :qtd;
    if (:qtd = 0) then
    begin
      insert into ops_banco (banco) values (new.banco);
    end
  end
  if (trim(new.compraouro) <> '') then
  begin
    select coalesce(count(*),0) from ops_compraouro where compraouro = new.compraouro into :qtd;
    if (:qtd = 0) then
    begin
      insert into ops_compraouro (compraouro) values  (new.compraouro);
    end
  end
  if (trim(new.cidade) <> '') then
  begin
    select coalesce(count(*),0) from ops_cidades where cidade = new.cidade into :qtd;
    if (:qtd = 0) then
    begin
      insert into ops_cidades (cidade) values  (new.cidade);
    end
  end
end
^

/* Trigger: OPS_HISTORICO_BI0 */
CREATE TRIGGER OPS_HISTORICO_BI0 FOR OPS_HISTORICO
ACTIVE BEFORE INSERT POSITION 0
AS
begin
 NEW.codhistorico = GEN_ID("GEN_OPS_HISTORICO", 1);
end
^

/* Trigger: PESSOABLOQUSUARIO_BI0 */
CREATE TRIGGER PESSOABLOQUSUARIO_BI0 FOR PESSOABLOQUSUARIO
ACTIVE BEFORE INSERT POSITION 0
AS
begin
  /* Trigger text */
  if (NEW.codpessoabloqusuario IS NULL) then
    NEW.codpessoabloqusuario = gen_id(GEN_PESSOABLOQUSUARIO_ID,1);
end
^

/* Trigger: WBOTATENDIMENTOPARAM_BI */
CREATE TRIGGER WBOTATENDIMENTOPARAM_BI FOR WBOTATENDIMENTOPARAM
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_wbotatendimentoparam_id,1);
end
^

/* Trigger: WBOTATENDIMENTO_BI */
CREATE TRIGGER WBOTATENDIMENTO_BI FOR WBOTATENDIMENTO
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
  begin
    new.id = gen_id(gen_wbotatendimento_id,1);
    new.DHABERTURA = current_timestamp;
  end
end
^

/* Trigger: WBOTATENDIMENTO_BU0 */
CREATE TRIGGER WBOTATENDIMENTO_BU0 FOR WBOTATENDIMENTO
ACTIVE BEFORE UPDATE POSITION 0
AS
begin
  /* Trigger text */
  if ((old.situacao = 'A') AND ((new.situacao = 'F') or (NEW.situacao = 'C'))) then
    NEW.DHFECHAMENTO = current_timestamp;
end
^

/* Trigger: WBOTCONTATO_BI */
CREATE TRIGGER WBOTCONTATO_BI FOR WBOTCONTATO
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_wbotcontato_id,1);
end
^

/* Trigger: WBOTCONVERSACONTATO_BI */
CREATE TRIGGER WBOTCONVERSACONTATO_BI FOR WBOTCONVERSACONTATO
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_wbotconversacontato_id,1);
end
^

/* Trigger: WBOTMENSAGEMAENVIAR_BI */
CREATE TRIGGER WBOTMENSAGEMAENVIAR_BI FOR WBOTMENSAGEMAENVIAR
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.id is null) then
    new.id = gen_id(gen_wbotmensagemaenviar_id,1);
end
^
SET TERM ; ^

